/**
 * @(#)Album.java  10 November 2006
 * Lab 10
 * @author Viera K. Proulx
 */
/**
 * Class to represent a recording album
 */
public class Album implements ISame<Album>{
  /** the title of this album */
  private String title;
  /** the artist featured in this album */
  private String artist;
  /** the year of release of this album */
  private int yor;
  
  /**
   * The full constructor
   * @param title the title of this album
   * @param artist the artist featured in this album
   * @param yor the year of release of this album
   */
  Album(String title, String artist, int yor){
    this.title = title;
    this.artist = artist;
    this.yor = yor;
  }
  
  /**
   * Extensional equality comparison:
   * is this album equal to the given album?
   * 
   * @param a the given album
   */
  public boolean same(Album a){
    return (this.title.equals(a.title) && 
        this.artist.equals(a.artist) &&
        this.yor == a.yor);
  }
  
  /*----------------------------------------
   * Accessors
   ----------------------------------------*/
   /**
   * accessor for the title of this album
   * @return the title
   */
  public String getTitle(){
    return this.title;
  }
  
  /**
   * accessor for the artist featured in this album
   * @return the featured artist
   */
  public String getArtist(){
    return this.artist;
  }
  
  /**
   * accessor for the year of release of this album
   * @return the year of release
   */
  public int getYor(){
    return this.yor;
  }
}
