/**
 * @(#)Album.java  10 November 2006
 * Lab 10
 * @author Viera K. Proulx
 */
import java.util.ArrayList;
/**
 * Class to represent a traversal over a list of recording albums
 * -- using ArrayList as the list data structure
 */
public class AlbumListTraversal implements Traversal<Album> {
  private ArrayList<Album> alist;
  private int first;
  
  /**
   * The full constructor
   * @param alist the <CODE>{@link ArrayList ArrayList}</CODE>
   * to traverse
   * @param index index for the first element in this traverrsal
   */
  protected AlbumListTraversal(ArrayList<Album> alist, int first){
    this.alist = alist;
    if (first <= this.alist.size()) 
      this.first = first;
    else 
      throw new RuntimeException("invalid index in the constructor");
  }
  
  /**
   * The initializing constructor
   * -- used to start the iterator for a given ArrayList
   * @param alist the <CODE>{@link ArrayList ArrayList}</CODE>
   * to traverse
   */
  public AlbumListTraversal(ArrayList<Album> alist){
    this(alist, 0);
  }
  
  /**
   * Are there any elements to traverse?
   * The valid range fof <CODE>index</CODE> is 
   * <CODE>0 <= index < size</CODE>
   */
  public boolean isEmpty() {
    return this.first == this.alist.size();
  }
  
  /**
   * Produce the first album in this traversal.
   * Throw a runtime exception if there is no data to traverse.
   * @return the first album in this traversal
   */
  public Album getFirst() {
    if (this.isEmpty())
      throw new RuntimeException
      ("can't retrieve current from an empty list");
    else
      return this.alist.get(first);
  }
  
  /**
   * Produce the the traversal for the rest of the data.
   * Throw a runtime exception if there is no data to traverse.
   * @return the traversal for the rest of this data
   */
   public Traversal<Album> getRest() {
    if (this.isEmpty())
      throw new RuntimeException
      ("can't advance further in an empty list");
    else
      return new AlbumListTraversal(this.alist, this.first + 1);
  }
}
