/**
 * @(#)Traversal 6 November 2006
 *
 * @author Viera K. Proulx
 */

/**
 * An interface that provides a functional iterator over a collection
 * of data of the type <CODE><T></CODE>.
 */
public interface Traversal<T> {
  
  /** 
   * Produce a traversal for the collection with the first element removed.
   * 
   * @return new traversal for a collection without the first element.
   */
  public Traversal<T> getRest(); 
  
  /** 
   * Provide the first element of this collection. 
   *  
   * @return the first element in the collection.
   */
  public T getFirst(); 
  
  /** 
   * Test whether there are any items in the collection.
   * 
   * @return true if the collection has no elements.
   */
  public boolean isEmpty(); 
}

